﻿namespace RockyCube
{
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Collections.Specialized;
    using System.Linq;

    using Infragistics.Olap;
    using Infragistics.Olap.FlatData;
    using System.Windows;

    public class CustomMeasureAggregator : Aggregator<double>
    {
        private FlatDataSource _flatDataSource;
        private IList<IMeasureViewModel> _measures;

        public CustomMeasureAggregator(FlatDataSource flatDataSource)
        {
            MessageBox.Show("1");
            this._flatDataSource = flatDataSource;
            this._measures = new List<IMeasureViewModel>();
            this._flatDataSource.Measures.CollectionChanging += this.Measures_CollectionChanging;
        }

        public override IAggregationResult<double, double> Evaluate(IAggregationResult<double, double> oldResult, IAggregateable aggregateable, IEnumerable items)
        {
            try
            {
                int step = 1;
                double result = 0;

                if (this._measures.Count > 0)
                {
                    LoggingClient.log("GOT HERE!!!: " + step++);
                    // implement your custom logic here
                    // you can get access to the measures stored in the list

                    // if({Base Units} > 0, {Gross Revenue} / {Base Units}, {Base Avg Sell Price}/($end-$begin) )

                    IMeasureViewModel grossRevenueViewModel =
                        this._measures.Where(mvm => mvm.Measure.Name == "GrossRevenue").FirstOrDefault();
                    LoggingClient.log("GOT HERE!!!: " + step++);

                    IAggregateable grossRevenueAggregateable = null;
                    if (grossRevenueViewModel != null)
                    {
                        grossRevenueAggregateable = grossRevenueViewModel.Measure as IAggregateable;
                    }

                    IMeasureViewModel baseUnitsMeasureViewModel =
                        this._measures.Where(mvm => mvm.Measure.Name == "BF_Units").FirstOrDefault();

                    IAggregateable baseUnitsAggregateable = null;
                    if (baseUnitsMeasureViewModel != null)
                    {
                        baseUnitsAggregateable = baseUnitsMeasureViewModel.Measure as IAggregateable;
                    }

                    LoggingClient.log("GOT HERE!!!: " + step++);
                    double grossRevenueSum = 0;
                    double baseUnitsSum = 0;

                    foreach (var item in items)
                    {
                        if (grossRevenueAggregateable != null)
                        {
                            grossRevenueSum += (int)grossRevenueAggregateable.GetValue(item);
                        }

                        if (baseUnitsAggregateable != null)
                        {
                            baseUnitsSum += (int)baseUnitsAggregateable.GetValue(item);
                        }
                    }

                    LoggingClient.log("GOT HERE!!!: " + step++);
                    if (baseUnitsSum > 0)
                        result += baseUnitsSum / grossRevenueSum;
                    else
                        result = 0;
                }

                LoggingClient.log("GOT HERE!!!: RESULT: "+result);
                return new SingleResult<double>(result);
            }
            catch (Exception e)
            {
                LoggingClient.log(e.ToString());
                return new SingleResult<double>(-42.0);
            }
        }

        public override IAggregationResult<double, double> Evaluate(IAggregationResult<double, double> oldResult, double value)
        {
            // you don't need this one
            throw new NotImplementedException();
        }

        private void Measures_CollectionChanging(object sender, NotifyCollectionChangedEventArgs e)
        {
            if (e.OldItems != null)
            {
                foreach (var newItem in e.OldItems)
                {
                    IMeasureViewModel measureViewModel = newItem as IMeasureViewModel;
                    if (measureViewModel != null)
                    {
                        this._measures.Remove(measureViewModel);
                    }
                }
            }

            if (e.NewItems != null)
            {
                foreach (var newItem in e.NewItems)
                {
                    IMeasureViewModel measureViewModel = newItem as IMeasureViewModel;
                    if (measureViewModel != null)
                    {
                        FlatMeasure measure = (FlatMeasure)measureViewModel.Measure;
                        if (measure.Aggregator != this)
                        {
                            this._measures.Add(measureViewModel);
                        }
                    }
                }
            }
        }
    }
}